/*
 * pstack - ץꥱ¸ʬ
 *          (ץꥱȤ߹ǻȤ饤֥ŪʬʬΥ)
 *
 * (C)Copyright 2009, Yashiro Takeshi <yashiromann@nifty.com>
 */

#include <basic.h>
#include <stdio.h>
#include <stdlib.h>
#include <tcode.h>
#include <tstring.h>
#include <string.h>
#include <btron/errcode.h>
#include "pstack.h"


static void usage()
{
    printf("Usage: pstack <tid>\n");
    printf("       pstack <tid>:<exefile>\n");
    printf("       pstack <tid>:<mapfile>\n\n");
    printf("Prints stack trace of a running task.\n\n");
}


int main(int argc, TC* argv[])
{
    int tid, i;
    char fname[128] = "";
    PstkSymbolTable* tbl = NULL;

    if (argc != 2) {
        usage();
        return ER_PAR;
    }

    /* Ŭ˰(tid, fname) parse  */
    tid = 0;
    for (i = 0;; i++) {
        if (argv[1][i] >= TK_0 && argv[1][i] <= TK_9) {
            tid *= 10;
            tid += (argv[1][i] - TK_0);
        }
        else {
            break;
        }
    }

    if (argv[1][i] == TK_COLN) {
        i++;
        tcstoeucs(fname, argv[1] + i);
    }
    else if (argv[1][i] != TNULL) {
        usage();
        return ER_PAR;
    }

    /* ܥơ֥ɤ߹ */
    if (strlen(fname) > 0) {
        tbl = load_symtab(fname);
        if (tbl == NULL) {
            ;
        }
    }

    /* оݥΥХåȥ졼ɽ */
    print_stacktrace(tid, tbl);

    if (tbl != NULL) {
        free_symtab(tbl);
        tbl = NULL;
    }

    return 0;
}
