#ifndef DEFINE_H_LIB_PSTACK
#define DEFINE_H_LIB_PSTACK

#include <basic.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct PstkSymbolDef_ {
    UW    addr;
    char* name;
} PstkSymbolDef;

typedef struct PstkSymbolTable_ {
    PstkSymbolDef* defs;
    int n;
    int nmax;
} PstkSymbolTable;

extern PstkSymbolTable* load_symtab(const char* fname);
extern void free_symtab(PstkSymbolTable* tbl);
extern const PstkSymbolDef* resolve_symbol(PstkSymbolTable* tbl, UW addr);
extern W print_stacktrace(W tid, PstkSymbolTable* tbl);

#ifdef __cplusplus
}
#endif

#endif /* DEFINE_H_LIB_PSTACK */
